﻿Type=Activity
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim ccBillede As ContentChooser
	Dim ccKvittering As ContentChooser
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private ivBaggrund As ImageView
	Private svOpretIndbo As ScrollView
	Private pnlOpretIndbo As Panel
	
	Private txtBeskrivelse As EditText
	Private txtKoebtDen As EditText
	Private txtKoebtSted As EditText
	Private txtOverskrift As EditText
	Private txtVaerdi As EditText
	Private ivBillede As ImageView
	Private ivKvittering As ImageView
	
	Private txtBilledeNavn As String
	Private txtKvitteringNavn As String
	
	Dim FotoCameraMsgBox As CustomMsgBox
	
	Dim FotoDestination As Int	'** 1 = billede, 2 = kvittering
	Dim billedeNummer As Int
	Dim billedeSource1 As Int	'** 1 = camera, 2 = fotos
	Dim billedeSource2 As Int	'** 1 = camera, 2 = fotos
	
	Dim exif As ExifData
End Sub

'**********************************************
'** Activity create
'**********************************************
Sub Activity_Create(FirstTime As Boolean)
	Try
		'Do not forget to load the layout file created with the visual designer. For example:
		'** Start det første layout
		Activity.LoadLayout("OpretIndboLayout")
		
		'** Første gang App køres
		If FirstTime Then
		End If

		'** Sæt panel ind i scrollview
		svOpretIndbo.Panel.LoadLayout("OpretIndboScrollPanel")
		svOpretIndbo.Panel.Height = ivKvittering.Top + 600 

		'** Initialize contentchooser
		ccBillede.Initialize("ccBillede")
		ccKvittering.Initialize("ccKvittering")
		
		'** Hent billede til billedenummer
		billedeNummer = DatabaseManager.HentNaesteBilledeNummer
		
		'** Sæt noget i billede og kvitteringsnavn
		billedeSource1 = 0
		billedeSource2 = 0
		txtBilledeNavn = "tempimage.jpg"
		txtKvitteringNavn = "tempimage.jpg"
		
		'** Sæt textbox baggrund
		Dim cd As ColorDrawable
		cd.Initialize(Colors.LightGray,10)  
		txtOverskrift.Background=cd 
		txtVaerdi.Background=cd
		txtKoebtDen.Background=cd
		txtKoebtSted.Background=cd
		Dim cd2 As ColorDrawable
		cd2.Initialize(Colors.LightGray,30)  
		txtBeskrivelse.Background=cd2

	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** Activity resume
'**********************************************
Sub Activity_Resume
	Try
		'** Billede
		If Main.intHarOpretIndboHentetBillede = True Then
			Dim tmpBillede As Bitmap
			
			tmpBillede = LoadBitmap(File.DirRootExternal, Main.strBilledeNavn)
			ivBillede.SetBackgroundImage(tmpBillede)

			'** Sæt har hentet billede i opret indbo til true
			Main.intHarOpretIndboHentetBillede = False
		
			txtBilledeNavn = Main.strBilledeNavn
		End If

		'** Kvittering
		If Main.intHarOpretIndboHentetKvittering = True Then
			Dim tmpBillede As Bitmap
			
			tmpBillede = LoadBitmap(File.DirRootExternal, Main.strKvitteringNavn)
			ivKvittering.SetBackgroundImage(tmpBillede)

			'** Sæt har hentet billede i opret indbo til true
			Main.intHarOpretIndboHentetKvittering = False
		
			txtKvitteringNavn = Main.strKvitteringNavn
		End If
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Log(errorMessage)
	End Try
End Sub

'**********************************************
'** Activity pause
'**********************************************
Sub Activity_Pause (UserClosed As Boolean)
	Try
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Log(errorMessage)
	End Try
End Sub

'**********************************************
'** KNAP: Tilbage til området
'**********************************************
Sub btnTilbage_Click
	Try
		StartActivity(Omraadet)
		Activity.Finish	
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** KNAP: Opret indbo
'**********************************************
Sub btnOpret_Click
	Try
		If txtOverskrift.Text <> "" AND txtVaerdi.Text <> "" AND txtKoebtDen.Text <> "" AND txtKoebtSted.Text <> "" AND txtBilledeNavn <> "" AND txtKvitteringNavn <> "" Then
			If DatabaseManager.OpretIndbo(txtBilledeNavn, txtOverskrift.Text, txtVaerdi.Text, txtKoebtDen.Text, txtBeskrivelse.Text, txtKoebtSted.Text, txtKvitteringNavn, Main.strValgtOmraade) > 0 Then
				ToastMessageShow("Indbo er oprettet!", True)
			
				'** Er billedet hentet fra fotos
				If billedeSource1 = 2 Then
					'** Kopier billeder
					Dim bmBillede As Bitmap
					Dim billedeStream As OutputStream
				
					bmBillede = ivBillede.Bitmap
					billedeStream = File.OpenOutput(File.DirRootExternal, txtBilledeNavn, False)
					bmBillede.WriteToStream(billedeStream, 100, "JPEG")
				End If
			
				'** Er billedet hentet fra fotos
				If billedeSource2 = 2 Then
					'** Kopier billeder
					Dim bmKvittering As Bitmap
					Dim kvitteringStream As OutputStream
				
					bmKvittering = ivKvittering.Bitmap
					kvitteringStream = File.OpenOutput(File.DirRootExternal, txtKvitteringNavn, False)
					bmKvittering.WriteToStream(kvitteringStream, 100, "JPEG")
				End If
				
				'** Der er ikke valgt nogle billede
				If billedeSource1 = 0 Then
					'** Kopier billeder
					Dim bmBillede As Bitmap
					Dim billedeStream As OutputStream
				
					bmBillede = ivBillede.Bitmap
					billedeStream = File.OpenOutput(File.DirRootExternal, txtBilledeNavn, False)
					bmBillede.WriteToStream(billedeStream, 100, "JPEG")
				End If
				If billedeSource2 = 0 Then
					'** Kopier billeder
					Dim bmKvittering As Bitmap
					Dim kvitteringStream As OutputStream
				
					bmKvittering = ivKvittering.Bitmap
					kvitteringStream = File.OpenOutput(File.DirRootExternal, txtKvitteringNavn, False)
					bmKvittering.WriteToStream(kvitteringStream, 100, "JPEG")
				End If
				
				'** Forlad siden
				btnTilbage_Click
			End If
		Else
			ToastMessageShow("Du skal udfylde alle felter!", True)
		End If
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** KNAP: Fjern keyboard
'**********************************************
Sub btnFaerdig_Click
	Try
		CallSubDelayed(Me, "HideKeyboard")
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Log(errorMessage)
	End Try	
End Sub

'**********************************************
'** Kvittering : Klik
'**********************************************
Sub ivKvittering_Click
	Try
		'** Sæt foto destination
		FotoDestination = 2
		Main.strValgtView = "OpretIndbo"
		
		'** Definer navn på billede
		Main.strKvitteringNavn = "Kvittering" &  billedeNummer & ".jpg"
		
		'** Spørg efter foto eller kamera
		FotoCameraMsgBox.Initialize(Activity, Me, "Default", "H", 3, 80%x, 280dip, Null)
		FotoCameraMsgBox.Title.Text = "Vælg foto kilde"
		FotoCameraMsgBox.ShowMessage("Vælg mellem foto eller kamera", "")
		FotoCameraMsgBox.YesButtonCaption.Text = "Foto"
		FotoCameraMsgBox.NoButtonCaption.Text = "Kamera"
		FotoCameraMsgBox.CancelButtonCaption.Text = "Annuller"	
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** KVITTERING: Klik på roter kvittering
'**********************************************
Sub btnRotateKvittering_Click
	Dim rbmp As RSImageProcessing
	Dim finalBitmap As Bitmap

	Try
		rbmp.Initialize		
		finalBitmap = ivKvittering.Bitmap
		finalBitmap = rbmp.rotateBitmap(finalBitmap, 90)
		ivKvittering.Bitmap = finalBitmap		
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** HentDato : Klik
'**********************************************
Sub ivHentDato_Click
	Try
		Dim dd As DateDialog
		Dim ret As Int

		'** Gem gamle farve
		txtKoebtDen.Tag = txtKoebtDen.Background
	
		dd.ShowCalendar = False
		dd.Year = DateTime.GetYear(DateTime.Now)
		dd.Month = DateTime.GetMonth(DateTime.Now)	
		dd.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)
		ret = dd.show("", "Vælg dato", "Ok", "Annuller", "", Null)
		
		If ret = -1 Then
			'** Sæt gamle farve
			txtKoebtDen.Background = txtKoebtDen.Tag
			txtKoebtDen.Text = dd.DayOfMonth & "-" & dd.Month & "-" & dd.Year
		End If
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** Billede : Klik
'**********************************************
Sub ivBillede_Click
	Try
		'** Sæt foto destination
		FotoDestination = 1
		Main.strValgtView = "OpretIndbo"
		
		'** Definer navn på billede
		Main.strBilledeNavn = "Billede" & billedeNummer & ".jpg"
		
		'** Spørg efter foto eller kamera
		FotoCameraMsgBox.Initialize(Activity, Me, "Default", "H", 3, 80%x, 280dip, Null)
		FotoCameraMsgBox.Title.Text = "Vælg foto kilde"
		FotoCameraMsgBox.ShowMessage("Vælg mellem foto eller kamera", "")
		FotoCameraMsgBox.YesButtonCaption.Text = "Foto"
		FotoCameraMsgBox.NoButtonCaption.Text = "Kamera"
		FotoCameraMsgBox.CancelButtonCaption.Text = "Annuller"
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** BILLEDE: Klik på roter billede
'**********************************************
Sub btnRotateBillede_Click
	Dim rbmp As RSImageProcessing
	Dim finalBitmap As Bitmap

	Try
		rbmp.Initialize		
		finalBitmap = ivBillede.Bitmap
		finalBitmap = rbmp.rotateBitmap(finalBitmap, 90)
		ivBillede.Bitmap = finalBitmap	
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try	
End Sub

'**********************************************
'** CustmMsgBox : Klik
'**********************************************
Sub Default_Click
	Try
		'** Der er valgt billede
		If FotoDestination = 1 Then
			'** Kamera valgt
			If FotoCameraMsgBox.ButtonSelected.ToLowerCase = "no" Then
				'** Fortæl hvor til billedet skal gemmes
				Main.intBilledeDestination = 1
				
				'** Start camera aktivity
				StartActivity(TagBillede)
				
				'** Sæt har hentet billede i opret indbo til true
				Main.intHarOpretIndboHentetBillede = True
				
				'** Sæt billede source
				billedeSource1 = 1
			End If
			'** Foto valgt
			If FotoCameraMsgBox.ButtonSelected.ToLowerCase = "yes" Then
				'** Start content chooser
				ccBillede.Show("image/*", "Vælg et billede")
				
				'** Sæt billede source
				billedeSource1 = 2
			End If
		End If
		'** Der er valgt kvittering
		If FotoDestination = 2 Then
			'** Foto valgt
			If FotoCameraMsgBox.ButtonSelected.ToLowerCase = "no" Then
				'** Fortæl hvor til billedet skal gemmes
				Main.intBilledeDestination = 2
				
				'** Start camera activity
				StartActivity(TagBillede)

				'** Sæt har hentet billede i opret indbo til true
				Main.intHarOpretIndboHentetKvittering = True
				
				'** Sæt billede source
				billedeSource2 = 1
			End If
			'** Kamera valgt
			If FotoCameraMsgBox.ButtonSelected.ToLowerCase = "yes" Then
				'** Start content chooser
				ccKvittering.Show("image/*", "Vælg et billede")
				
				'** Sæt billede source
				billedeSource2 = 2
			End If
		End If				
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** ContentChooser : Result for billede
'**********************************************
Sub ccBillede_Result(Success As Boolean, Dir As String, FileName As String)
	Dim rbmp As RSImageProcessing
	Dim finalBitmap As Bitmap
	
	Try
		If Success Then
			'Dim newFileName = GetPathFromContentResult(FileName)
			'Dim newFileName2 = newFileName.SubString(newFileName.LastIndexOf("/") + 1)
			File.Copy(Dir ,FileName, File.DirRootExternal ,"tempFile.jpg")
			
			'** Initialize exif
			exif.Initialize(File.DirRootExternal ,"tempFile.jpg")
		
			Dim temp As String
			temp = exif.getAttribute(exif.TAG_ORIENTATION)

			'** Billedet er roteret (taget i landscape)
			If temp = "6" Then
				rbmp.Initialize		
				finalBitmap = LoadBitmap(Dir, FileName)
				finalBitmap = rbmp.rotateBitmap(finalBitmap, 90)
				ivBillede.Bitmap = finalBitmap
			Else
				finalBitmap = LoadBitmap(Dir, FileName)
				ivBillede.Bitmap = finalBitmap
			End If
			
			'** Slet temp billede fil
			File.Delete(File.DirRootExternal ,"tempFile.jpg")
			
			txtBilledeNavn = "billede" & billedeNummer & ".jpg"	
		End If
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** ContentChooser : Result for kvittering
'**********************************************
Sub ccKvittering_Result(Success As Boolean, Dir As String, FileName As String)
	Dim rbmp As RSImageProcessing
	Dim finalBitmap As Bitmap
	
	Try
		If Success Then
			'Dim newFileName = GetPathFromContentResult(FileName)
			'Dim newFileName2 = newFileName.SubString(newFileName.LastIndexOf("/") + 1)
			File.Copy(Dir ,FileName, File.DirRootExternal ,"tempFile.jpg")
			
			'** Initialize exif
			exif.Initialize(File.DirRootExternal ,"tempFile.jpg")
		
			Dim temp As String
			temp = exif.getAttribute(exif.TAG_ORIENTATION)

			'** Billedet er roteret (taget i landscape)
			If temp = "6" Then
				rbmp.Initialize		
				finalBitmap = LoadBitmap(Dir, FileName)
				finalBitmap = rbmp.rotateBitmap(finalBitmap, 90)
				ivKvittering.Bitmap = finalBitmap
			Else
				finalBitmap = LoadBitmap(Dir, FileName)
				ivKvittering.Bitmap = finalBitmap
			End If
			
			'** Slet temp billede fil
			File.Delete(File.DirRootExternal ,"tempFile.jpg")
			
			txtKvitteringNavn = "kvittering" & billedeNummer & ".jpg"	
		End If
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub

'**********************************************
'** Private sub : GetPathFromContentResult
'**********************************************
Sub GetPathFromContentResult(UriString As String) As String
  If UriString.StartsWith("/") Then Return UriString 'If the user used a file manager to choose the image
  Dim Cursor1 As Cursor
  Dim Uri1 As Uri
  Dim Proj() As String = Array As String("_data")
  Dim cr As ContentResolver
  cr.Initialize("")
  If UriString.StartsWith("content://com.android.providers.media.documents") Then
  Dim i As Int = UriString.IndexOf("%3A")
  Dim id As String = UriString.SubString(i + 3)
  Uri1.Parse("content://media/external/images/media")
  Cursor1 = cr.Query(Uri1, Proj, "_id = ?", Array As String(id), "")
  Else
  Uri1.Parse(UriString)
  Cursor1 = cr.Query(Uri1, Proj, "", Null, "")
  End If
  Cursor1.Position = 0
  Dim res As String
  res = Cursor1.GetString("_data")
  Cursor1.Close
  Return res
End Sub

'**********************************************
'** Hide Keyboard sub
'**********************************************
Sub HideKeyboard
	Try
		Dim phone1 As Phone
		phone1.HideKeyboard(Activity)
	Catch
		Dim errorMessage As String
		errorMessage = LastException.Message
		Msgbox(errorMessage, "ERROR!")
	End Try
End Sub
